<!DOCTYPE html>
<html>
<head>
  <title>Artillery report</title>
  <script src='https://ajax.googleapis.com/ajax/libs/jquery/2.1.3/jquery.min.js'></script>
  <script src='https://cdnjs.cloudflare.com/ajax/libs/d3/3.5.0/d3.min.js' charset='utf-8'></script>
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/metrics-graphics/2.6.0/metricsgraphics.min.css" />
  <script src="https://cdnjs.cloudflare.com/ajax/libs/metrics-graphics/2.6.0/metricsgraphics.min.js"></script>

  <link href='https://fonts.googleapis.com/css?family=Open+Sans:400,300,700' rel='stylesheet' type='text/css'>
  <link href='https://fonts.googleapis.com/css?family=PT+Serif:400,700,400italic' rel='stylesheet' type='text/css'>
  <link href='https://netdna.bootstrapcdn.com/font-awesome/4.2.0/css/font-awesome.css' rel='stylesheet' type='text/css'>
  <link href='https://maxcdn.bootstrapcdn.com/bootstrap/3.2.0/css/bootstrap.min.css' rel='stylesheet' type='text/css'>

  <script src="https://cdnjs.cloudflare.com/ajax/libs/moment.js/2.10.6/moment.min.js"></script>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/lodash.js/3.10.1/lodash.min.js"></script>

  <script src="https://cdnjs.cloudflare.com/ajax/libs/ace/1.2.0/ace.js" charset="utf-8"></script>

  <style>
  body, p, li {
    font-family: sans-serif;
    font-size: 10pt;
  }

  h1 {
    font-size: 18pt;
    font-weight: bold;
  }

  #errorsContainer > p {
    color: #009900;
  }

  #footer {
    padding: 1em;
    font-size: 0.8em;
    color: #999;
    text-align: center;
    margin-top: 1em;
    background-color: #eee;
  }
  #editor {
    font-size: 8pt;
    height: 20em;
  }
  </style>

  <script>
  window.Report = {
  "aggregate": {
    "timestamp": "2021-02-21T18:41:35.035Z",
    "scenariosCreated": 18612,
    "scenariosCompleted": 1195,
    "requestsCompleted": 2669,
    "latency": {
      "min": 256.7,
      "max": 48297.3,
      "median": 905.5,
      "p95": 15956,
      "p99": 18341.1
    },
    "rps": {
      "count": 20086,
      "mean": 29.51
    },
    "scenarioDuration": {
      "min": 2454.6,
      "max": 295598,
      "median": 3232,
      "p95": 24121.1,
      "p99": 33613.5
    },
    "scenarioCounts": {
      "CalculatePrice minute": 6279,
      "GetSpec": 6226,
      "CalculatePrice fixed": 6107
    },
    "errors": {
      "ETIMEDOUT": 17409,
      "ENOTFOUND": 4,
      "ESOCKETTIMEDOUT": 4
    },
    "codes": {
      "200": 1195,
      "302": 1474
    },
    "matches": 0,
    "customStats": {},
    "counters": {},
    "scenariosAvoided": 0,
    "phases": [
      {
        "duration": 60,
        "name": "Warm up",
        "arrivalRate": 5
      },
      {
        "duration": 120,
        "name": "Ramp up load",
        "arrivalRate": 5,
        "rampTo": 50
      },
      {
        "duration": 300,
        "name": "Sustained load",
        "arrivalRate": 50
      }
    ]
  },
  "intermediate": [
    {
      "timestamp": "2021-02-21T18:30:24.155Z",
      "scenariosCreated": 49,
      "scenariosCompleted": 32,
      "requestsCompleted": 86,
      "latency": {
        "min": 266.6,
        "max": 1225,
        "median": 845.6,
        "p95": 1042.2,
        "p99": 1197.4
      },
      "rps": {
        "count": 93,
        "mean": 9.52
      },
      "scenarioDuration": {
        "min": 3208.6,
        "max": 3593.8,
        "median": 3312.3,
        "p95": 3572.5,
        "p99": 3593.8
      },
      "scenarioCounts": {
        "CalculatePrice minute": 15,
        "GetSpec": 20,
        "CalculatePrice fixed": 14
      },
      "errors": {},
      "codes": {
        "200": 42,
        "302": 44
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 17,
      "pendingRequests": 7,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2021-02-21T18:30:34.149Z",
      "scenariosCreated": 50,
      "scenariosCompleted": 49,
      "requestsCompleted": 97,
      "latency": {
        "min": 268.8,
        "max": 1638.2,
        "median": 383.5,
        "p95": 1033.3,
        "p99": 1448.2
      },
      "rps": {
        "count": 98,
        "mean": 9.83
      },
      "scenarioDuration": {
        "min": 3220.3,
        "max": 4023.8,
        "median": 3303.7,
        "p95": 3560.2,
        "p99": 4023.8
      },
      "scenarioCounts": {
        "GetSpec": 21,
        "CalculatePrice minute": 15,
        "CalculatePrice fixed": 14
      },
      "errors": {},
      "codes": {
        "200": 49,
        "302": 48
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 18,
      "pendingRequests": 8,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2021-02-21T18:30:44.157Z",
      "scenariosCreated": 50,
      "scenariosCompleted": 49,
      "requestsCompleted": 99,
      "latency": {
        "min": 273.4,
        "max": 16915.5,
        "median": 826.1,
        "p95": 1021.1,
        "p99": 9235.6
      },
      "rps": {
        "count": 100,
        "mean": 10
      },
      "scenarioDuration": {
        "min": 3180.2,
        "max": 19432.9,
        "median": 3300.1,
        "p95": 3610.4,
        "p99": 19432.9
      },
      "scenarioCounts": {
        "CalculatePrice fixed": 22,
        "GetSpec": 12,
        "CalculatePrice minute": 16
      },
      "errors": {},
      "codes": {
        "200": 49,
        "302": 50
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 19,
      "pendingRequests": 9,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2021-02-21T18:30:54.147Z",
      "scenariosCreated": 50,
      "scenariosCompleted": 50,
      "requestsCompleted": 100,
      "latency": {
        "min": 273.5,
        "max": 16228.5,
        "median": 592.5,
        "p95": 1039.1,
        "p99": 8708.8
      },
      "rps": {
        "count": 100,
        "mean": 10.02
      },
      "scenarioDuration": {
        "min": 3228.3,
        "max": 18591.6,
        "median": 3302.6,
        "p95": 3429.4,
        "p99": 18591.6
      },
      "scenarioCounts": {
        "GetSpec": 17,
        "CalculatePrice minute": 16,
        "CalculatePrice fixed": 17
      },
      "errors": {},
      "codes": {
        "200": 50,
        "302": 50
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 19,
      "pendingRequests": 9,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2021-02-21T18:31:04.149Z",
      "scenariosCreated": 50,
      "scenariosCompleted": 52,
      "requestsCompleted": 105,
      "latency": {
        "min": 269.7,
        "max": 32645.3,
        "median": 816.9,
        "p95": 1076.4,
        "p99": 26518.4
      },
      "rps": {
        "count": 103,
        "mean": 10.3
      },
      "scenarioDuration": {
        "min": 3169.7,
        "max": 35022.2,
        "median": 3319.4,
        "p95": 7177.3,
        "p99": 34800.1
      },
      "scenarioCounts": {
        "GetSpec": 14,
        "CalculatePrice minute": 22,
        "CalculatePrice fixed": 14
      },
      "errors": {},
      "codes": {
        "200": 52,
        "302": 53
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 17,
      "pendingRequests": 7,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2021-02-21T18:31:14.142Z",
      "scenariosCreated": 50,
      "scenariosCompleted": 49,
      "requestsCompleted": 96,
      "latency": {
        "min": 274.3,
        "max": 3335.5,
        "median": 806.4,
        "p95": 1030.6,
        "p99": 2382.6
      },
      "rps": {
        "count": 98,
        "mean": 9.82
      },
      "scenarioDuration": {
        "min": 3171.3,
        "max": 3644.9,
        "median": 3316.6,
        "p95": 3590.7,
        "p99": 3644.9
      },
      "scenarioCounts": {
        "GetSpec": 13,
        "CalculatePrice fixed": 22,
        "CalculatePrice minute": 15
      },
      "errors": {},
      "codes": {
        "200": 48,
        "302": 48
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 18,
      "pendingRequests": 9,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2021-02-21T18:31:24.150Z",
      "scenariosCreated": 60,
      "scenariosCompleted": 18,
      "requestsCompleted": 36,
      "latency": {
        "min": 279.9,
        "max": 1371.4,
        "median": 889.1,
        "p95": 1250.4,
        "p99": 1371.4
      },
      "rps": {
        "count": 85,
        "mean": 8.52
      },
      "scenarioDuration": {
        "min": 3227.4,
        "max": 21123.9,
        "median": 3289.2,
        "p95": 14126.9,
        "p99": 21123.9
      },
      "scenarioCounts": {
        "GetSpec": 20,
        "CalculatePrice minute": 25,
        "CalculatePrice fixed": 15
      },
      "errors": {},
      "codes": {
        "200": 11,
        "302": 25
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 60,
      "pendingRequests": 58,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2021-02-21T18:31:34.165Z",
      "scenariosCreated": 107,
      "scenariosCompleted": 23,
      "requestsCompleted": 80,
      "latency": {
        "min": 287.1,
        "max": 23310.9,
        "median": 919.1,
        "p95": 15962.3,
        "p99": 21121.6
      },
      "rps": {
        "count": 161,
        "mean": 16.43
      },
      "scenarioDuration": {
        "min": 3225.8,
        "max": 25697.2,
        "median": 4553,
        "p95": 20946.5,
        "p99": 25697.2
      },
      "scenarioCounts": {
        "GetSpec": 38,
        "CalculatePrice minute": 36,
        "CalculatePrice fixed": 33
      },
      "errors": {},
      "codes": {
        "200": 26,
        "302": 54
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 144,
      "pendingRequests": 139,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2021-02-21T18:31:44.171Z",
      "scenariosCreated": 144,
      "scenariosCompleted": 15,
      "requestsCompleted": 46,
      "latency": {
        "min": 285.8,
        "max": 16188,
        "median": 938.8,
        "p95": 15951,
        "p99": 16188
      },
      "rps": {
        "count": 179,
        "mean": 17.99
      },
      "scenarioDuration": {
        "min": 3201.8,
        "max": 18427.2,
        "median": 10300.6,
        "p95": 18382.6,
        "p99": 18427.2
      },
      "scenarioCounts": {
        "GetSpec": 40,
        "CalculatePrice minute": 47,
        "CalculatePrice fixed": 57
      },
      "errors": {
        "ETIMEDOUT": 25
      },
      "codes": {
        "200": 11,
        "302": 35
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 248,
      "pendingRequests": 272,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2021-02-21T18:31:54.176Z",
      "scenariosCreated": 185,
      "scenariosCompleted": 8,
      "requestsCompleted": 49,
      "latency": {
        "min": 286.5,
        "max": 15981.8,
        "median": 923.3,
        "p95": 15932.3,
        "p99": 15981.8
      },
      "rps": {
        "count": 223,
        "mean": 22.32
      },
      "scenarioDuration": {
        "min": 3303.3,
        "max": 18317.8,
        "median": 3355.5,
        "p95": 18317.8,
        "p99": 18317.8
      },
      "scenarioCounts": {
        "GetSpec": 61,
        "CalculatePrice minute": 66,
        "CalculatePrice fixed": 58
      },
      "errors": {
        "ETIMEDOUT": 81
      },
      "codes": {
        "200": 11,
        "302": 38
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 344,
      "pendingRequests": 446,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2021-02-21T18:32:04.180Z",
      "scenariosCreated": 229,
      "scenariosCompleted": 12,
      "requestsCompleted": 40,
      "latency": {
        "min": 288.6,
        "max": 15993.6,
        "median": 1002,
        "p95": 15913.7,
        "p99": 15993.6
      },
      "rps": {
        "count": 259,
        "mean": 25.93
      },
      "scenarioDuration": {
        "min": 3250.2,
        "max": 25377.1,
        "median": 13816.3,
        "p95": 25258.4,
        "p99": 25377.1
      },
      "scenarioCounts": {
        "CalculatePrice minute": 72,
        "GetSpec": 71,
        "CalculatePrice fixed": 86
      },
      "errors": {
        "ETIMEDOUT": 130
      },
      "codes": {
        "200": 9,
        "302": 31
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 431,
      "pendingRequests": 665,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2021-02-21T18:32:14.164Z",
      "scenariosCreated": 251,
      "scenariosCompleted": 3,
      "requestsCompleted": 29,
      "latency": {
        "min": 293.6,
        "max": 15893.5,
        "median": 916.8,
        "p95": 8615.6,
        "p99": 15893.5
      },
      "rps": {
        "count": 278,
        "mean": 27.86
      },
      "scenarioDuration": {
        "min": 3403.6,
        "max": 10315.8,
        "median": 10278.1,
        "p95": 10315.8,
        "p99": 10315.8
      },
      "scenarioCounts": {
        "CalculatePrice minute": 83,
        "CalculatePrice fixed": 89,
        "GetSpec": 79
      },
      "errors": {
        "ETIMEDOUT": 163
      },
      "codes": {
        "200": 3,
        "302": 26
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 516,
      "pendingRequests": 914,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2021-02-21T18:32:24.189Z",
      "scenariosCreated": 292,
      "scenariosCompleted": 8,
      "requestsCompleted": 35,
      "latency": {
        "min": 289.1,
        "max": 19782.8,
        "median": 7840.9,
        "p95": 15952.6,
        "p99": 19782.8
      },
      "rps": {
        "count": 317,
        "mean": 31.67
      },
      "scenarioDuration": {
        "min": 3303,
        "max": 25375.3,
        "median": 10279.7,
        "p95": 25375.3,
        "p99": 25375.3
      },
      "scenarioCounts": {
        "CalculatePrice fixed": 84,
        "GetSpec": 85,
        "CalculatePrice minute": 123
      },
      "errors": {
        "ETIMEDOUT": 222
      },
      "codes": {
        "200": 10,
        "302": 25
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 578,
      "pendingRequests": 1196,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2021-02-21T18:32:34.177Z",
      "scenariosCreated": 328,
      "scenariosCompleted": 4,
      "requestsCompleted": 21,
      "latency": {
        "min": 837.9,
        "max": 15957.3,
        "median": 7888.5,
        "p95": 15952.6,
        "p99": 15957.3
      },
      "rps": {
        "count": 348,
        "mean": 34.87
      },
      "scenarioDuration": {
        "min": 3325.7,
        "max": 40726.9,
        "median": 17837,
        "p95": 40726.9,
        "p99": 40726.9
      },
      "scenarioCounts": {
        "CalculatePrice minute": 110,
        "GetSpec": 112,
        "CalculatePrice fixed": 106
      },
      "errors": {
        "ETIMEDOUT": 232
      },
      "codes": {
        "200": 1,
        "302": 20
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 670,
      "pendingRequests": 1523,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2021-02-21T18:32:44.222Z",
      "scenariosCreated": 358,
      "scenariosCompleted": 0,
      "requestsCompleted": 8,
      "latency": {
        "min": 865.4,
        "max": 15966.2,
        "median": 8029.7,
        "p95": 15966.2,
        "p99": 15966.2
      },
      "rps": {
        "count": 366,
        "mean": 36.45
      },
      "scenarioDuration": {
        "min": null,
        "max": null,
        "median": null,
        "p95": null,
        "p99": null
      },
      "scenarioCounts": {
        "CalculatePrice fixed": 118,
        "GetSpec": 119,
        "CalculatePrice minute": 121
      },
      "errors": {
        "ETIMEDOUT": 297
      },
      "codes": {
        "302": 8
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 731,
      "pendingRequests": 1881,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2021-02-21T18:32:54.222Z",
      "scenariosCreated": 408,
      "scenariosCompleted": 1,
      "requestsCompleted": 11,
      "latency": {
        "min": 847.4,
        "max": 15935.2,
        "median": 7923.1,
        "p95": 15933.2,
        "p99": 15935.2
      },
      "rps": {
        "count": 417,
        "mean": 41.78
      },
      "scenarioDuration": {
        "min": 33386.3,
        "max": 33386.3,
        "median": 33386.3,
        "p95": 33386.3,
        "p99": 33386.3
      },
      "scenarioCounts": {
        "CalculatePrice fixed": 148,
        "CalculatePrice minute": 132,
        "GetSpec": 128
      },
      "errors": {
        "ETIMEDOUT": 328
      },
      "codes": {
        "200": 1,
        "302": 10
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 810,
      "pendingRequests": 2287,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2021-02-21T18:33:04.241Z",
      "scenariosCreated": 438,
      "scenariosCompleted": 0,
      "requestsCompleted": 6,
      "latency": {
        "min": 295.6,
        "max": 15927.5,
        "median": 4483.4,
        "p95": 15927.5,
        "p99": 15927.5
      },
      "rps": {
        "count": 444,
        "mean": 44.36
      },
      "scenarioDuration": {
        "min": null,
        "max": null,
        "median": null,
        "p95": null,
        "p99": null
      },
      "scenarioCounts": {
        "CalculatePrice minute": 164,
        "GetSpec": 159,
        "CalculatePrice fixed": 115
      },
      "errors": {
        "ETIMEDOUT": 355
      },
      "codes": {
        "200": 1,
        "302": 5
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 893,
      "pendingRequests": 2725,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2021-02-21T18:33:14.234Z",
      "scenariosCreated": 488,
      "scenariosCompleted": 1,
      "requestsCompleted": 5,
      "latency": {
        "min": 830.4,
        "max": 41837.4,
        "median": 7919.3,
        "p95": 41837.4,
        "p99": 41837.4
      },
      "rps": {
        "count": 492,
        "mean": 49.25
      },
      "scenarioDuration": {
        "min": 10382.5,
        "max": 10382.5,
        "median": 10382.5,
        "p95": 10382.5,
        "p99": 10382.5
      },
      "scenarioCounts": {
        "CalculatePrice fixed": 143,
        "CalculatePrice minute": 183,
        "GetSpec": 162
      },
      "errors": {
        "ETIMEDOUT": 404
      },
      "codes": {
        "302": 5
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 976,
      "pendingRequests": 3212,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2021-02-21T18:33:24.175Z",
      "scenariosCreated": 498,
      "scenariosCompleted": 0,
      "requestsCompleted": 5,
      "latency": {
        "min": 921.4,
        "max": 15924.8,
        "median": 7947.9,
        "p95": 15924.8,
        "p99": 15924.8
      },
      "rps": {
        "count": 504,
        "mean": 50.7
      },
      "scenarioDuration": {
        "min": null,
        "max": null,
        "median": null,
        "p95": null,
        "p99": null
      },
      "scenarioCounts": {
        "CalculatePrice fixed": 155,
        "CalculatePrice minute": 168,
        "GetSpec": 175
      },
      "errors": {
        "ETIMEDOUT": 434
      },
      "codes": {
        "302": 5
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 1040,
      "pendingRequests": 3711,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2021-02-21T18:33:34.176Z",
      "scenariosCreated": 500,
      "scenariosCompleted": 0,
      "requestsCompleted": 4,
      "latency": {
        "min": 849,
        "max": 15898.8,
        "median": 984.2,
        "p95": 15898.8,
        "p99": 15898.8
      },
      "rps": {
        "count": 504,
        "mean": 50.4
      },
      "scenarioDuration": {
        "min": null,
        "max": null,
        "median": null,
        "p95": null,
        "p99": null
      },
      "scenarioCounts": {
        "GetSpec": 163,
        "CalculatePrice fixed": 171,
        "CalculatePrice minute": 166
      },
      "errors": {
        "ETIMEDOUT": 484
      },
      "codes": {
        "302": 4
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 1056,
      "pendingRequests": 4211,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2021-02-21T18:33:44.177Z",
      "scenariosCreated": 500,
      "scenariosCompleted": 0,
      "requestsCompleted": 2,
      "latency": {
        "min": 7881,
        "max": 15880.9,
        "median": 11880.9,
        "p95": 15880.9,
        "p99": 15880.9
      },
      "rps": {
        "count": 502,
        "mean": 50.2
      },
      "scenarioDuration": {
        "min": null,
        "max": null,
        "median": null,
        "p95": null,
        "p99": null
      },
      "scenarioCounts": {
        "CalculatePrice fixed": 168,
        "GetSpec": 168,
        "CalculatePrice minute": 164
      },
      "errors": {
        "ETIMEDOUT": 502
      },
      "codes": {
        "302": 2
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 1054,
      "pendingRequests": 4711,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2021-02-21T18:33:54.174Z",
      "scenariosCreated": 500,
      "scenariosCompleted": 0,
      "requestsCompleted": 1,
      "latency": {
        "min": 7854.6,
        "max": 7854.6,
        "median": 7854.6,
        "p95": 7854.6,
        "p99": 7854.6
      },
      "rps": {
        "count": 501,
        "mean": 50.1
      },
      "scenarioDuration": {
        "min": null,
        "max": null,
        "median": null,
        "p95": null,
        "p99": null
      },
      "scenarioCounts": {
        "CalculatePrice fixed": 149,
        "GetSpec": 179,
        "CalculatePrice minute": 172
      },
      "errors": {
        "ETIMEDOUT": 500
      },
      "codes": {
        "302": 1
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 1054,
      "pendingRequests": 5211,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2021-02-21T18:34:04.177Z",
      "scenariosCreated": 500,
      "scenariosCompleted": 0,
      "requestsCompleted": 1,
      "latency": {
        "min": 15998.7,
        "max": 15998.7,
        "median": 15998.7,
        "p95": 15998.7,
        "p99": 15998.7
      },
      "rps": {
        "count": 501,
        "mean": 50.1
      },
      "scenarioDuration": {
        "min": null,
        "max": null,
        "median": null,
        "p95": null,
        "p99": null
      },
      "scenarioCounts": {
        "CalculatePrice fixed": 170,
        "GetSpec": 159,
        "CalculatePrice minute": 171
      },
      "errors": {
        "ETIMEDOUT": 501
      },
      "codes": {
        "302": 1
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 1053,
      "pendingRequests": 5711,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2021-02-21T18:34:14.175Z",
      "scenariosCreated": 500,
      "scenariosCompleted": 0,
      "requestsCompleted": 1,
      "latency": {
        "min": 7887.4,
        "max": 7887.4,
        "median": 7887.4,
        "p95": 7887.4,
        "p99": 7887.4
      },
      "rps": {
        "count": 501,
        "mean": 50.1
      },
      "scenarioDuration": {
        "min": null,
        "max": null,
        "median": null,
        "p95": null,
        "p99": null
      },
      "scenarioCounts": {
        "CalculatePrice fixed": 177,
        "GetSpec": 166,
        "CalculatePrice minute": 157
      },
      "errors": {
        "ETIMEDOUT": 500
      },
      "codes": {
        "302": 1
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 1053,
      "pendingRequests": 6211,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2021-02-21T18:34:24.175Z",
      "scenariosCreated": 500,
      "scenariosCompleted": 0,
      "requestsCompleted": 56,
      "latency": {
        "min": 810.8,
        "max": 16033.8,
        "median": 7956.1,
        "p95": 15990.6,
        "p99": 16032.7
      },
      "rps": {
        "count": 556,
        "mean": 55.6
      },
      "scenarioDuration": {
        "min": null,
        "max": null,
        "median": null,
        "p95": null,
        "p99": null
      },
      "scenarioCounts": {
        "CalculatePrice minute": 182,
        "GetSpec": 161,
        "CalculatePrice fixed": 157
      },
      "errors": {
        "ETIMEDOUT": 495
      },
      "codes": {
        "302": 56
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 1058,
      "pendingRequests": 6711,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2021-02-21T18:34:34.176Z",
      "scenariosCreated": 501,
      "scenariosCompleted": 4,
      "requestsCompleted": 101,
      "latency": {
        "min": 7309.9,
        "max": 16840.9,
        "median": 15906.1,
        "p95": 16100.8,
        "p99": 16555.5
      },
      "rps": {
        "count": 595,
        "mean": 59.5
      },
      "scenarioDuration": {
        "min": 10413.6,
        "max": 25436.6,
        "median": 25348.6,
        "p95": 25436.6,
        "p99": 25436.6
      },
      "scenarioCounts": {
        "CalculatePrice fixed": 162,
        "CalculatePrice minute": 175,
        "GetSpec": 164
      },
      "errors": {
        "ETIMEDOUT": 450,
        "ENOTFOUND": 2
      },
      "codes": {
        "200": 6,
        "302": 95
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 1103,
      "pendingRequests": 7205,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2021-02-21T18:34:44.178Z",
      "scenariosCreated": 500,
      "scenariosCompleted": 6,
      "requestsCompleted": 64,
      "latency": {
        "min": 367,
        "max": 20069,
        "median": 1129.9,
        "p95": 16781.8,
        "p99": 19955.4
      },
      "rps": {
        "count": 559,
        "mean": 55.9
      },
      "scenarioDuration": {
        "min": 3515.6,
        "max": 29689.6,
        "median": 21004.6,
        "p95": 29689.6,
        "p99": 29689.6
      },
      "scenarioCounts": {
        "CalculatePrice fixed": 174,
        "GetSpec": 163,
        "CalculatePrice minute": 163
      },
      "errors": {
        "ETIMEDOUT": 284
      },
      "codes": {
        "200": 5,
        "302": 59
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 1313,
      "pendingRequests": 7700,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2021-02-21T18:34:54.186Z",
      "scenariosCreated": 500,
      "scenariosCompleted": 7,
      "requestsCompleted": 94,
      "latency": {
        "min": 267.4,
        "max": 23578.4,
        "median": 965.2,
        "p95": 8087,
        "p99": 23028.8
      },
      "rps": {
        "count": 586,
        "mean": 58.54
      },
      "scenarioDuration": {
        "min": 3192.6,
        "max": 10319.6,
        "median": 3408.6,
        "p95": 10319.6,
        "p99": 10319.6
      },
      "scenarioCounts": {
        "CalculatePrice fixed": 142,
        "GetSpec": 187,
        "CalculatePrice minute": 171
      },
      "errors": {},
      "codes": {
        "200": 8,
        "302": 86
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 1806,
      "pendingRequests": 8192,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2021-02-21T18:35:04.178Z",
      "scenariosCreated": 500,
      "scenariosCompleted": 9,
      "requestsCompleted": 106,
      "latency": {
        "min": 265.9,
        "max": 29580.7,
        "median": 7854.3,
        "p95": 16135.1,
        "p99": 25995.4
      },
      "rps": {
        "count": 596,
        "mean": 59.66
      },
      "scenarioDuration": {
        "min": 3164.6,
        "max": 18499.4,
        "median": 10285.6,
        "p95": 18499.4,
        "p99": 18499.4
      },
      "scenarioCounts": {
        "CalculatePrice minute": 189,
        "CalculatePrice fixed": 157,
        "GetSpec": 154
      },
      "errors": {
        "ETIMEDOUT": 1218
      },
      "codes": {
        "200": 11,
        "302": 95
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 1079,
      "pendingRequests": 8682,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2021-02-21T18:35:14.178Z",
      "scenariosCreated": 500,
      "scenariosCompleted": 13,
      "requestsCompleted": 115,
      "latency": {
        "min": 268.5,
        "max": 48297.3,
        "median": 7866.4,
        "p95": 15979.9,
        "p99": 27718.6
      },
      "rps": {
        "count": 602,
        "mean": 60.26
      },
      "scenarioDuration": {
        "min": 3203,
        "max": 32556.6,
        "median": 17241.6,
        "p95": 31479.3,
        "p99": 32556.6
      },
      "scenarioCounts": {
        "CalculatePrice fixed": 194,
        "CalculatePrice minute": 164,
        "GetSpec": 142
      },
      "errors": {
        "ETIMEDOUT": 462
      },
      "codes": {
        "200": 13,
        "302": 102
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 1104,
      "pendingRequests": 9169,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2021-02-21T18:35:24.186Z",
      "scenariosCreated": 500,
      "scenariosCompleted": 12,
      "requestsCompleted": 59,
      "latency": {
        "min": 834.9,
        "max": 19872.1,
        "median": 15413.7,
        "p95": 16134.9,
        "p99": 19543.2
      },
      "rps": {
        "count": 550,
        "mean": 55
      },
      "scenarioDuration": {
        "min": 10192.6,
        "max": 33564.6,
        "median": 24727.3,
        "p95": 33113.1,
        "p99": 33564.6
      },
      "scenarioCounts": {
        "GetSpec": 176,
        "CalculatePrice fixed": 161,
        "CalculatePrice minute": 163
      },
      "errors": {
        "ETIMEDOUT": 477
      },
      "codes": {
        "200": 8,
        "302": 51
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 1115,
      "pendingRequests": 9660,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2021-02-21T18:35:34.177Z",
      "scenariosCreated": 500,
      "scenariosCompleted": 16,
      "requestsCompleted": 73,
      "latency": {
        "min": 256.7,
        "max": 22067.3,
        "median": 1014.7,
        "p95": 16059.9,
        "p99": 21640.3
      },
      "rps": {
        "count": 544,
        "mean": 54.45
      },
      "scenarioDuration": {
        "min": 2474.6,
        "max": 21715.6,
        "median": 2885.1,
        "p95": 16209.4,
        "p99": 21715.6
      },
      "scenarioCounts": {
        "CalculatePrice fixed": 162,
        "GetSpec": 170,
        "CalculatePrice minute": 168
      },
      "errors": {
        "ETIMEDOUT": 497,
        "ENOTFOUND": 2
      },
      "codes": {
        "200": 30,
        "302": 43
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 1100,
      "pendingRequests": 10131,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2021-02-21T18:35:44.185Z",
      "scenariosCreated": 500,
      "scenariosCompleted": 58,
      "requestsCompleted": 55,
      "latency": {
        "min": 450.1,
        "max": 29129.8,
        "median": 1013.2,
        "p95": 15575.8,
        "p99": 28471.2
      },
      "rps": {
        "count": 503,
        "mean": 50.3
      },
      "scenarioDuration": {
        "min": 2464.6,
        "max": 33275.6,
        "median": 3077.1,
        "p95": 17235.2,
        "p99": 33217.3
      },
      "scenarioCounts": {
        "CalculatePrice fixed": 153,
        "CalculatePrice minute": 165,
        "GetSpec": 182
      },
      "errors": {
        "ETIMEDOUT": 30
      },
      "codes": {
        "200": 52,
        "302": 3
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 1512,
      "pendingRequests": 10579,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2021-02-21T18:35:54.176Z",
      "scenariosCreated": 500,
      "scenariosCompleted": 42,
      "requestsCompleted": 45,
      "latency": {
        "min": 444.6,
        "max": 20018.1,
        "median": 7489.9,
        "p95": 15978.4,
        "p99": 20018.1
      },
      "rps": {
        "count": 503,
        "mean": 50.35
      },
      "scenarioDuration": {
        "min": 2454.6,
        "max": 18291.6,
        "median": 9496.6,
        "p95": 17961.2,
        "p99": 18291.6
      },
      "scenarioCounts": {
        "CalculatePrice minute": 153,
        "GetSpec": 181,
        "CalculatePrice fixed": 166
      },
      "errors": {
        "ETIMEDOUT": 973
      },
      "codes": {
        "200": 42,
        "302": 3
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 997,
      "pendingRequests": 11037,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2021-02-21T18:36:04.183Z",
      "scenariosCreated": 500,
      "scenariosCompleted": 46,
      "requestsCompleted": 51,
      "latency": {
        "min": 455.2,
        "max": 15981.4,
        "median": 7303.3,
        "p95": 15720.2,
        "p99": 15979.2
      },
      "rps": {
        "count": 503,
        "mean": 50.3
      },
      "scenarioDuration": {
        "min": 2472.6,
        "max": 25596.6,
        "median": 9511.1,
        "p95": 19309,
        "p99": 25596.6
      },
      "scenarioCounts": {
        "GetSpec": 175,
        "CalculatePrice fixed": 167,
        "CalculatePrice minute": 158
      },
      "errors": {
        "ETIMEDOUT": 454
      },
      "codes": {
        "200": 48,
        "302": 3
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 997,
      "pendingRequests": 11489,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2021-02-21T18:40:44.825Z",
      "scenariosCreated": 99,
      "scenariosCompleted": 13,
      "requestsCompleted": 6,
      "latency": {
        "min": 460.5,
        "max": 15532.6,
        "median": 4312,
        "p95": 15532.6,
        "p99": 15532.6
      },
      "rps": {
        "count": 101,
        "mean": 0.36
      },
      "scenarioDuration": {
        "min": 2481.3,
        "max": 295598,
        "median": 9513.6,
        "p95": 294329,
        "p99": 295598
      },
      "scenarioCounts": {
        "CalculatePrice minute": 38,
        "GetSpec": 41,
        "CalculatePrice fixed": 20
      },
      "errors": {
        "ETIMEDOUT": 89
      },
      "codes": {
        "200": 3,
        "302": 3
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 994,
      "pendingRequests": 11584,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2021-02-21T18:40:54.818Z",
      "scenariosCreated": 4748,
      "scenariosCompleted": 554,
      "requestsCompleted": 723,
      "latency": {
        "min": 277.3,
        "max": 4668.5,
        "median": 510,
        "p95": 1162.5,
        "p99": 1447.7
      },
      "rps": {
        "count": 4916,
        "mean": 494.57
      },
      "scenarioDuration": {
        "min": 2464.8,
        "max": 7451,
        "median": 2530.7,
        "p95": 3527.1,
        "p99": 3820.3
      },
      "scenarioCounts": {
        "CalculatePrice fixed": 1563,
        "CalculatePrice minute": 1563,
        "GetSpec": 1622
      },
      "errors": {
        "ESOCKETTIMEDOUT": 4,
        "ETIMEDOUT": 989
      },
      "codes": {
        "200": 554,
        "302": 169
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 4195,
      "pendingRequests": 15777,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2021-02-21T18:41:04.853Z",
      "scenariosCreated": 1679,
      "scenariosCompleted": 1,
      "requestsCompleted": 69,
      "latency": {
        "min": 287.3,
        "max": 19044.8,
        "median": 7834.2,
        "p95": 15973.9,
        "p99": 18581.9
      },
      "rps": {
        "count": 1746,
        "mean": 174.08
      },
      "scenarioDuration": {
        "min": 10286.9,
        "max": 10286.9,
        "median": 10286.9,
        "p95": 10286.9,
        "p99": 10286.9
      },
      "scenarioCounts": {
        "GetSpec": 527,
        "CalculatePrice fixed": 584,
        "CalculatePrice minute": 568
      },
      "errors": {},
      "codes": {
        "200": 4,
        "302": 65
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 5873,
      "pendingRequests": 17454,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2021-02-21T18:41:14.869Z",
      "scenariosCreated": 0,
      "scenariosCompleted": 9,
      "requestsCompleted": 64,
      "latency": {
        "min": 278.2,
        "max": 25514.2,
        "median": 15903.3,
        "p95": 16072.3,
        "p99": 24382.5
      },
      "rps": {
        "count": 52,
        "mean": 5.33
      },
      "scenarioDuration": {
        "min": 10382.3,
        "max": 28212.5,
        "median": 18327.1,
        "p95": 28212.5,
        "p99": 28212.5
      },
      "scenarioCounts": {},
      "errors": {
        "ETIMEDOUT": 3535
      },
      "codes": {
        "200": 12,
        "302": 52
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 2329,
      "pendingRequests": 17442,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2021-02-21T18:41:24.872Z",
      "scenariosCreated": 0,
      "scenariosCompleted": 23,
      "requestsCompleted": 21,
      "latency": {
        "min": 7286.8,
        "max": 38674.4,
        "median": 15318.8,
        "p95": 37003.9,
        "p99": 38674.4
      },
      "rps": {
        "count": 0,
        "mean": null
      },
      "scenarioDuration": {
        "min": 19466,
        "max": 37132.3,
        "median": 26129.7,
        "p95": 36710,
        "p99": 37132.3
      },
      "scenarioCounts": {},
      "errors": {
        "ETIMEDOUT": 2260
      },
      "codes": {
        "200": 21
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 46,
      "pendingRequests": 17421,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2021-02-21T18:41:34.891Z",
      "scenariosCreated": 0,
      "scenariosCompleted": 8,
      "requestsCompleted": 4,
      "latency": {
        "min": 15309.2,
        "max": 39798,
        "median": 15316.7,
        "p95": 39798,
        "p99": 39798
      },
      "rps": {
        "count": 0,
        "mean": null
      },
      "scenarioDuration": {
        "min": 33286.9,
        "max": 45460.7,
        "median": 33554.3,
        "p95": 45460.7,
        "p99": 45460.7
      },
      "scenarioCounts": {},
      "errors": {
        "ETIMEDOUT": 38
      },
      "codes": {
        "200": 4
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 0,
      "pendingRequests": 17417,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2021-02-21T18:41:34.994Z",
      "scenariosCreated": 0,
      "scenariosCompleted": 0,
      "requestsCompleted": 0,
      "latency": {
        "min": null,
        "max": null,
        "median": null,
        "p95": null,
        "p99": null
      },
      "rps": {
        "count": 0,
        "mean": null
      },
      "scenarioDuration": {
        "min": null,
        "max": null,
        "median": null,
        "p95": null,
        "p99": null
      },
      "scenarioCounts": {},
      "errors": {},
      "codes": {},
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 0,
      "pendingRequests": 17417,
      "scenariosAvoided": 0
    }
  ]
};
  </script>

  <style>
      h1 {
        line-height: 200%;
      }

      body {
          background-color: #fcfcfc;
      }

      .container {
          width: 100%;
          min-width: 960px;
      }
  </style>


</head>
<body>

<div class="container">

<div class="row" id="header">
  <div class="col-lg-4 col-lg-offset-4">
    <pre style="font-size: 5pt; background-color: #fcfcfc; border: none;">
            _   _ _ _                                                _
  __ _ _ __| |_(_) | | ___ _ __ _   _      _ __ ___ _ __   ___  _ __| |_
 / _` | '__| __| | | |/ _ \ '__| | | |    | '__/ _ \ '_ \ / _ \| '__| __|
| (_| | |  | |_| | | |  __/ |  | |_| |    | | |  __/ |_) | (_) | |  | |_
 \__,_|_|   \__|_|_|_|\___|_|   \__, |    |_|  \___| .__/ \___/|_|   \__|
                                |___/              |_|

    </pre>
  </div>
</div>

<div class="row">
  <div class="col-lg-12">
    <h1 class="text-center" id="page-title">Test run on <span id="timestamp">date</span></h1>
  </div>
</div>

<div class="row">
  <div class="col-lg-3">
    <p><strong>Summary</strong></p>
    <table class="table table-bordered table-hover table-condensed">
      <tbody>
        <tr>
          <td>Test duration</td>
          <td><span id="testDuration">0</span> sec</td>
        </tr>
        <tr>
          <td>Scenarios created</td>
          <td><span id="scenariosCreated">0</span></td>
        </tr>

        <tr>
          <td>Scenarios completed</td>
          <td><span id="scenariosCompleted">0</span></td>
        </tr>
      </tbody>
    </table>
  </div>

  <div class="col-lg-5" id="scenarioCountsContainer">
    <div>
      <strong>Scenario counts:</strong>

      <p></p>

      <table class="table table-bordered table-hover table-condensed" id="scenarioCounts">
      </table>
    </div>
  </div>

  <div class="col-lg-1">
    <div id="codesContainer">
      <strong>Codes</strong>

      <p></p>

      <table class="table table-bordered table-hover table-condensed" id="codes">
      </table>
    </div>
  </div>

  <div class="col-lg-3">
    <div id="errorsContainer">
      <strong>Errors</strong>

      <p></p>

      <table class="table table-bordered table-hover table-condensed" id="errors">
      </table>
    </div>
  </div>
</div> <!-- /.row -->

<div class="row">
  <div class="text-center col-lg-12">
    <h2>Charts</h2>
  </div>
</div>

<div class="row">
  <div class="latency-histogram text-center col-lg-12"></div>
</div>

<div class="row">
  <div class="latency text-center col-lg-12"></div>
</div>

<div class="latency-legend"></div>

<div class="row">

</div>

<div class="row">
  <div class="concurrency text-center col-lg-12"></div>
</div>

<div class="row">
  <div class="rps-mean text-center col-lg-12"></div>
</div>
<div class="row">
  <div class="rps-count text-center col-lg-12"></div>
</div>

<div class="row">
  <div class="codes-line text-center col-lg-12"></div>
</div>
<div class="row">
  <div class="errors-line text-center col-lg-12"></div>
</div>


  


</div>

<div class="row">
  <div class="col-lg-8 col-lg-offset-2">
    <h3 class="text-center">Raw report data</h3>
    <p>This is the raw JSON stats output that the report was generated from.</p>
    <div id="editor">
    </div>
  </div>
</div>

<script>
var editor = ace.edit("editor");
editor.getSession().setMode("ace/mode/javascript");
editor.setValue(JSON.stringify(Report, null, 2));
editor.gotoLine(1);editor.setHighlightActiveLine(false);

var l = _;

$('#timestamp').html(moment(Report.aggregate.timestamp).format('DD MMM YYYY HH:mm:SS'));
$('#testDuration').html(l.size(Report.intermediate) * 10);
$('#scenariosCompleted').html(Report.aggregate.scenariosCompleted);
$('#scenariosCreated').html(Report.aggregate.scenariosCreated);

var markers = [];
if(l.size(Report.phases) > 0) {
  markers = l.foldl(Report.phases, function(acc, phase, index) {
    var label = phase.name || 'Phase ' + (index + 1);
    var timestamp = (index === 0) ? 0 : Report.phases[index - 1].duration + acc[index - 1].timestamp;

    acc.push({
      timestamp: timestamp,
      label: label
    });

    return acc;
  }, []);
}

if (l.size(Report.aggregate.scenarioCounts) > 0) {
  l.each(Report.aggregate.scenarioCounts, function(count, name) {
    var $tdName = $('<td>' + name + '</td>');
    var percentage = Math.round(count / Report.aggregate.scenariosCreated * 100 * 1000) / 1000;
    var $tdCount = $('<td>' + count + ' (' + percentage + '%)' + '</td>');
    var $el = $('<tr></tr>')
      .append($tdName)
      .append($tdCount)
      .appendTo($('#scenarioCounts'));
  });
} else {
  $('#scenarioCountsContainer').hide();
}

if (l.size(Report.aggregate.codes) > 0) {
  l.each(Report.aggregate.codes, function(count, code) {
    var anchor = '';
    if (code >= 100 && code < 200) {
      anchor = '#1xx_Informational';
    } else if (code >= 200 && code < 300) {
      anchor = '#2xx_Success';
    } else if (code >= 300 && code < 400) {
      anchor = '#3xx_Redirection';
    } else if (code >= 400 && code < 500) {
      anchor = '#4xx_Client_Error';
    } else if (code >= 500 && code < 600) {
      anchor = '#5xx_Server_Error';
    }

    var $a = $('<a>' + code + '</a>').attr('href', 'https://en.wikipedia.org/wiki/List_of_HTTP_status_codes' + anchor);
    var $td = $('<td></td>').append($a);
    var $el = $('<tr></tr>')
      .append($td)
      .append($('<td>' + count + '</td>'))
      .appendTo($('#codes'));
  });
} else {
  $('#codesContainer').hide();
}

if (l.size(Report.aggregate.errors) > 0) {
  l.each(Report.aggregate.errors, function(count, code) {
    var $el = $('<tr></tr>')
      .append($('<td>' + code + '</td>'))
      .append($('<td>' + count + '</td>'))
      .appendTo($('#errors'));
  });
} else {
  $('#errorsContainer > p').html('&#10004; Test completed without network or OS errors.');
}

var histogramData = l.map(Report.aggregate.latency, function(v, k) { return {bin: k, value: v} });

MG.data_graphic({
  chart_type: 'bar',
  x_label: 'Percentile',
  y_label: '(ms)',
  animate_on_load: true,
  title: 'Overall Latency Distribution',
  description: 'Distribution of all observed response latencies',
  target: '.latency-histogram',
  data: histogramData,
  x_accessor: 'bin',
  y_accessor: 'value',
  binned: true,
  height: 250,
  interpolate: 'monotone',
  padding_percentage: 0,
  bar_orientation: 'vertical',
  width: 450
});

var chartData = l.map(
  window.Report.intermediate,
  function(o,i) {
    return {
      timestamp: i*10+10,

      rpsMean: o.rps.mean,
      rpsCount: o.rps.count,
      concurrency: o.concurrency,
      latencyMax: o.latency.max,
      latencyp99: o.latency.p99,
      latencyp95: o.latency.p95,
      latencyMedian: o.latency.median,
      latencyMin: o.latency.min
    }
  });

//
// Response codes
//

if (l.size(Report.aggregate.codes) > 0) {
  var codesData = l.foldl(Report.intermediate, function(acc, o, i) {
    var res = {};
    res.timestamp = i*10+10;
    l.each(o.codes, function(count, code) {
      res[code] = count;
    });
    acc.push(res);
    return acc;
  }, []);
  var uniqueCodes = l.foldl(Report.intermediate, function(acc, o) {
    l.each(o.codes, function(count, code) {
      if (l.indexOf(acc, code) === -1) {
        acc.push(code);
      }
    });
    return acc;
  }, []);

  MG.data_graphic({
    x_label: 'Time',
    y_label: 'Count',
    title: 'HTTP codes',
    description: 'Occurence of HTTP response codes',
    target: '.codes-line',
    data: codesData,
    x_accessor: 'timestamp',
    y_accessor: uniqueCodes,
    legend: uniqueCodes,
    right: 50,
    chart_type: 'line',
    area: false,
    markers: markers,
    width: 900
  });
}

//
// Errors
//

if (l.size(Report.aggregate.errors) > 0) {
  var errorData = l.foldl(Report.intermediate, function(acc, o, i) {
    var res = {};
    res.timestamp = i*10+10;
    l.each(o.errors, function(count, name) {
      res[name] = count;
    });
    acc.push(res);
    return acc;
  }, []);
  var uniqueErrors = l.foldl(Report.intermediate, function(acc, o) {
    l.each(o.errors, function(count, name) {
      if (l.indexOf(acc, name) === -1) {
        acc.push(name);
      }
    });
    return acc;
  }, []);

  MG.data_graphic({
    title: 'Error Codes',
    description: 'Occurence of error codes',
    target: '.errors-line',
    data: errorData,
    x_accessor: 'timestamp',
    y_accessor: uniqueErrors,
    chart_type: 'line',
    area: false,
    markers: markers
  });

}

//
// Latency
//
MG.data_graphic({
  chart_type: 'line',
  x_label: 'Time',
  y_label: '(ms)',
  animate_on_load: true,
  area: false,
  title: "Latency At Intervals",
  description: "Latency values at different points during the test run",
  data: chartData,
  target: '.latency',
  width: 900,
  x_accessor: 'timestamp',
  y_accessor: ['latencyMin', 'latencyMedian', 'latencyp95', 'latencyMax'],
  legend: ['min', 'p50', 'p95', 'max'],
  //legend_target: '.latency-legend',
  right: 50,
  interpolate: 'monotone',
  mouseover: function(d, i) {
  },
  markers: markers
        });

            MG.data_graphic({
            animate_on_load: true,
            area: false,
            y_label: 'Count',
            x_label: 'Time',
            title: 'Concurrent users',
            description: 'Concurrent users',
            data: chartData,
            target: '.concurrency',
            x_accessor: 'timestamp',
            y_accessor: ['concurrency'],
            interpolate: 'monotone',
            markers: markers,
            width: 900
            });

MG.data_graphic({
  animate_on_load: true,
  area: false,
  y_label: 'Count',
  x_label: 'Time',
  title: 'Mean RPS',
  description: 'Mean requests per second',
  data: chartData,
  target: '.rps-mean',
  x_accessor: 'timestamp',
  y_accessor: ['rpsMean'],
  interpolate: 'monotone',
  markers: markers,
  width: 900
});

MG.data_graphic({
  animate_on_load: true,
  area: false,
  y_label: 'Count',
  x_label: 'Time',
  title: 'RPS Count',
  description: 'Count of requests per second',
  data: chartData,
  target: '.rps-count',
  x_accessor: 'timestamp',
  y_accessor: ['rpsCount'],
  interpolate: 'monotone',
  markers: markers,
  width: 900
});
</script>
<div id="footer">
  <footer>This report was created with <a href="https://artillery.io">Artillery</a> - free open-source load-testing for HTTP and WebSockets</footer>
</div>
</body>
</html>
